﻿using Syncfusion.SfChart.XForms;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace LiveSplineAreaSample
{
    public class SplineAreaSample : ContentPage
    {
        SfChart chart;
        StackLayout stackLayout;
        ObservableCollection<Model> data;
        DateTime time = DateTime.Now;
        DateTime dataTime = new DateTime(2015, 01, 1);
        Random random = new Random();
        int count;
    
        public SplineAreaSample()
        {
            chart = new SfChart();
            data = new ObservableCollection<Model>();
            chart.VerticalOptions = LayoutOptions.FillAndExpand;

            stackLayout = new StackLayout();
            stackLayout.VerticalOptions = LayoutOptions.FillAndExpand;

            DateTimeAxis xAxis = new DateTimeAxis();
            xAxis.LabelStyle.LabelFormat = "HH: mm: ss";
            xAxis.AutoScrollingDelta = 5;
            xAxis.AutoScrollingDeltaType = DateTimeDeltaType.Seconds;
            chart.PrimaryAxis = xAxis;

            chart.SecondaryAxis = new NumericalAxis()
            {
                Minimum = 0,
                Maximum = 100
            };

            SplineAreaSeries splineAreaseries = new SplineAreaSeries();
            splineAreaseries.ItemsSource = data;
            splineAreaseries.XBindingPath = "date";
            splineAreaseries.YBindingPath = "Value";
            chart.Series.Add(splineAreaseries);
            chart.ChartBehaviors.Add(new ChartZoomPanBehavior { EnablePanning = true, EnableZooming = false, EnableDoubleTap = false });
            LoadData();
            stackLayout.Children.Add(chart);
            Content = stackLayout;       
        }

        public void LoadData()
        {
            Device.StartTimer(new TimeSpan(0, 0, 0, 0, 500), () =>
            {
                data.Add(new Model(time, random.Next(0, 100)));
                time = time.AddMilliseconds(1000);
                count++;
                return true;
            });
        }
    }
}

